#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"

#define TIME_OFF -1     //^C}[gpȂꍇ
#define TIME_UP 0       //^CAbv
#define LED_FL 10
#define TIME_FILTER_MAX 1    //x[X^C}JEgl
#define DI_FILT_MAX 4            //DItB^̃TvO
#define DI_MAX 3
#define	CNT_INIT_MAX 10     //10ms~10 = 100ms
#define BTN_ON_KEEP  20
#define RED_LIMID 128

#define SLAVE_ADRS 0x3E//0x3E 0x7C
#define LINE1_ADRS 0x40
#define LINE2_TOP (0x40 +0x80)
#define FUNC1_SET 0x38
#define FUNC2_SET 0x39
#define INT_OSC 0x14
#define CONST_SET 0x77 //0x73
#define PWR_ICON_SET 0x54 //0x56
#define FOLLOWER_SET 0x6C
#define CLR_DISP 0x01
#define DISP_ONOFF_SET 0x0D
#define LINE_MAX 16

typedef enum{
    LED_R = 0,
    LED_G,
    LED_B,
    LED_MAX        
}LED_MODE_NO;

typedef struct{
    void (*red7)(void);
    void (*red6)(void);
    void (*red5)(void);
    void (*red4)(void);
    void (*red3)(void);
    void (*red2)(void);
    void (*red1)(void);
    void (*red0)(void);
    void (*green7)(void);
    void (*green6)(void);
    void (*green5)(void);
    void (*green4)(void);
    void (*green3)(void);
    void (*green2)(void);
    void (*green1)(void);
    void (*green0)(void);    
    void (*blue7)(void);
    void (*blue6)(void);
    void (*blue5)(void);
    void (*blue4)(void);
    void (*blue3)(void);
    void (*blue2)(void);
    void (*blue1)(void);
    void (*blue0)(void);         
}FUNC_SET;

typedef struct{
    uint8_t wp;
    uint8_t buf[DI_MAX][DI_FILT_MAX];
    uint8_t di[DI_MAX];
}DIFILT_TYP;

uint8_t red;
uint8_t green;
uint8_t blue;
uint8_t colormd;
bool cntflg;
bool btnflg[DI_MAX];
int16_t timLed= LED_FL;
int16_t timdifilt;   //DItB^N
int16_t timbtnkeep[DI_MAX];
uint8_t CntInit;	//̂ݎgp
DIFILT_TYP difilt;
FUNC_SET led;
uint8_t initmoji[2][16] ={"RGB LED-TEST    ","         Ver1.00"};

/* vg^Cv錾*/
void mainApp(void);
void mainTimer(void);
void makeWavePattern(void);
void makeNpWave(void);
void WaveStart(void);
void Set1code(void);
void Set0code(void);
void DiFilter(void);
void BtnCnt(uint8_t md, bool plus);
void LcdInit(void);
void DspLine2Top(void);
void DspLine2TopCursor(uint8_t no);
void DspClear(void);
void DispSet(void);

/* Main application */
void main(void)
{
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(mainTimer);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    
	CntInit = CNT_INIT_MAX;
	while(CntInit > 0){  //0ɂȂ܂ŃtB^{
        DiFilter();         //DItB^
        __delay_ms(10);     //10msxDItB^
        CntInit--;
        timdifilt = TIME_UP;
	}
    
    LcdInit();

    red=0;
    green=0;
    blue=0;
    cntflg = true;
    
    while (1)
    {
        DiFilter();
        mainApp();
    }
}
/* TMR0I[o[t[荞݂ł̏  */
/* ^C}Ǘ֐ */
void mainTimer(void){
    uint8_t i;
    
    if( timLed > TIME_UP ){
      timLed--;
    }
    if( timdifilt > TIME_UP ){
      timdifilt--;
    }
    
    for(i=0;i<DI_MAX;i++){
        if( timbtnkeep[i] > TIME_UP ){
            timbtnkeep[i]--;
        }
    }
}
/* C */
void mainApp(void){
    uint8_t i;
    
    if( timLed == TIME_UP){
        timLed = LED_FL;
        if(cntflg){
            cntflg = false;
            makeWavePattern();
            WaveStart();
            DispSet();
        }
        DspLine2TopCursor(colormd);
    }
    
    for(i=0; i < DI_MAX; i++){
        if( difilt.di[i] == 0){
            if( btnflg[i] == false ){
                btnflg[i] = true;
                timbtnkeep[i] = BTN_ON_KEEP;
                
                switch(i){
                    case 0:
                        BtnCnt(colormd,true);
                        cntflg = true;
                        break;
                    case 1:
                        BtnCnt(colormd,false);
                        cntflg = true;
                        break;
                    case 2:
                        if(++colormd >=LED_MAX){
                            colormd = LED_R;
                        }
                        break;
                }
            }
            else{
                if(timbtnkeep[i] == TIME_UP){
                    timbtnkeep[i] = BTN_ON_KEEP;
                    
                    switch(i){
                        case 0:
                            BtnCnt(colormd,true);
                            cntflg = true;
                            break;
                        case 1:
                            BtnCnt(colormd,false);
                            cntflg = true;
                            break;
                    }
                }
            }
        }
        else{
            btnflg[i] = false;
            timbtnkeep[i] = TIME_OFF;
        }
    }
}
/* LEDp^[*/
void makeWavePattern(void){
    //Ԃ̃p^[i֐o^j
    (red & 0x80) ? (led.red7 = Set1code) : (led.red7 = Set0code);
    (red & 0x40) ? (led.red6 = Set1code) : (led.red6 = Set0code);
    (red & 0x20) ? (led.red5 = Set1code) : (led.red5 = Set0code);
    (red & 0x10) ? (led.red4 = Set1code) : (led.red4 = Set0code);
    (red & 0x08) ? (led.red3 = Set1code) : (led.red3 = Set0code);
    (red & 0x04) ? (led.red2 = Set1code) : (led.red2 = Set0code);     
    (red & 0x02) ? (led.red1 = Set1code) : (led.red1 = Set0code);
    (red & 0x01) ? (led.red0 = Set1code) : (led.red0 = Set0code);
    //΂̃p^[i֐o^j
    (green & 0x80) ? (led.green7 = Set1code) : (led.green7 = Set0code);
    (green & 0x40) ? (led.green6 = Set1code) : (led.green6 = Set0code);
    (green & 0x20) ? (led.green5 = Set1code) : (led.green5 = Set0code);
    (green & 0x10) ? (led.green4 = Set1code) : (led.green4 = Set0code);
    (green & 0x08) ? (led.green3 = Set1code) : (led.green3 = Set0code);
    (green & 0x04) ? (led.green2 = Set1code) : (led.green2 = Set0code);     
    (green & 0x02) ? (led.green1 = Set1code) : (led.green1 = Set0code);
    (green & 0x01) ? (led.green0 = Set1code) : (led.green0 = Set0code);
    //̃p^[i֐o^j
    (blue & 0x80) ? (led.blue7 = Set1code) : (led.blue7 = Set0code);
    (blue & 0x40) ? (led.blue6 = Set1code) : (led.blue6 = Set0code);
    (blue & 0x20) ? (led.blue5 = Set1code) : (led.blue5 = Set0code);
    (blue & 0x10) ? (led.blue4 = Set1code) : (led.blue4 = Set0code);
    (blue & 0x08) ? (led.blue3 = Set1code) : (led.blue3 = Set0code);
    (blue & 0x04) ? (led.blue2 = Set1code) : (led.blue2 = Set0code);     
    (blue & 0x02) ? (led.blue1 = Set1code) : (led.blue1 = Set0code);
    (blue & 0x01) ? (led.blue0 = Set1code) : (led.blue0 = Set0code);
}

/* ^C~Og`̑M*/
void WaveStart(void){
    //Ԃ̃p^[
    led.red7();
    led.red6();
    led.red5();
    led.red4();
    led.red3();
    led.red2();
    led.red1();
    led.red0();
    //΂̃p^[
    led.green7();
    led.green6();
    led.green5();
    led.green4();
    led.green3();
    led.green2();
    led.green1();
    led.green0();
    //̃p^[
    led.blue7();
    led.blue6();
    led.blue5();
    led.blue4();
    led.blue3();
    led.blue2();
    led.blue1();
    led.blue0();    
}
/* {^ɂl̍XV */
void BtnCnt(uint8_t md, bool plus){
    
    switch(md){
        case LED_R:
            if(plus){
                //if(++red > RED_LIMID ){
                //    red = 0;
                //}
                ++red;
            }
            else{
                //if(--red == 255 ){
                //    red = RED_LIMID;
                //}
                --red;
            }
            break;
        case LED_G:
            if(plus){
                ++green;
            }
            else{
                --green;
            }           
            break;
        case LED_B:
            if(plus){
                ++blue;
            }
            else{
                --blue;
            }                   
            break;
    }
}
/* DiFilter function add */
void DiFilter(void){
    uint8_t i;

    if( timdifilt == TIME_UP ){
        timdifilt = TIME_FILTER_MAX;
        difilt.buf[0][difilt.wp] = IO_RB0_GetValue();
        difilt.buf[1][difilt.wp] = IO_RB2_GetValue();
        difilt.buf[2][difilt.wp] = IO_RB3_GetValue();
        
        for(i=0; i < DI_MAX; i++){
            if( difilt.buf[i][0] == difilt.buf[i][1] &&
            difilt.buf[i][1] == difilt.buf[i][2] &&
            difilt.buf[i][2] == difilt.buf[i][3] ){ //4vmF
            difilt.di[i] = difilt.buf[i][0];
            }
        }

        if( ++difilt.wp >= DI_FILT_MAX ){
          difilt.wp = 0;
        }
    }
}
/* 1 code ̃^C~O */
void Set1code(void){
    //1 code̗
    IO_RA0_SetHigh();//DOHIGH
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    //NOP();
    IO_RA0_SetLow();//DOLOW
    NOP();
    //NOP();
}
/* 0 code ̃^C~O */
void Set0code(void){
    //0 code̗
    IO_RA0_SetHigh();//DOHIGH
    NOP();
    //NOP();
    IO_RA0_SetLow();//DOLOW
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    //NOP();   
}
/* LCD̏ */
void LcdInit(void){
    uint8_t i;
    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FUNC1_SET ); //WrbgoXE2LINE\
    __delay_us(40);
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FUNC2_SET ); //gR}h
    __delay_us(40);
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, INT_OSC ); //g
    __delay_us(40);    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, CONST_SET ); //RgXg1
    __delay_us(40);    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, PWR_ICON_SET );//RgXg2
    __delay_us(40);   
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FOLLOWER_SET );//tH[
    __delay_ms(250);
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FUNC1_SET ); //gR}hIt
    __delay_us(40);
    
    DspClear();
    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, DISP_ONOFF_SET );
    __delay_us(40);
    
    for( i = 0; i < sizeof(initmoji[0]); i++ ){
        I2C1_Write1ByteRegister(SLAVE_ADRS,LINE1_ADRS,initmoji[0][i]);
    }  
    
    //I2C1_WriteNBytes( SLAVE_ADRS,&initmoji[0][0], sizeof(initmoji[0]));
    //DspLine2Top();

    //for( i = 0; i < sizeof(initmoji[1]); i++ ){
    //    I2C1_Write1ByteRegister(SLAVE_ADRS,LINE1_ADRS,initmoji[1][i]);
    //}        
    //__delay_ms(2000);
 
}
    
/* LCD̕\2iڂɃZbg */
void DspLine2Top(void){
    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, LINE2_TOP );
    __delay_us(40);    
}
/* LCD̕\NA */
void DspClear(void){
  
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, CLR_DISP );
    __delay_us(40);
}
/* J[\̈ړ */
void DspLine2TopCursor(uint8_t no){
    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, LINE2_TOP + no * 5 );
    __delay_us(40);    
    
}
/* DispSet function add */
void DispSet(void){
    uint8_t i;
    uint8_t line2[LINE_MAX];
    uint8_t r_100;
    uint8_t r_10;
    uint8_t r_1;
    uint8_t g_100;
    uint8_t g_10;
    uint8_t g_1;
    uint8_t b_100;
    uint8_t b_10;
    uint8_t b_1;    
    //0x30ĕR[h09𐶐
    r_100 = (red /100) + 0x30;
    r_10 = ((red % 100) / 10) +0x30;
    r_1 = ((red % 100) % 10) + 0x30;
    g_100 = (green /100) + 0x30;
    g_10 = ((green % 100) / 10) + 0x30;
    g_1 = ((green % 100) % 10) + 0x30;    
    b_100 = ( blue /100) + 0x30;
    b_10 = ((blue % 100) / 10) +0x30;
    b_1 = ((blue % 100) % 10) +0x30;
    
    if(r_100 == '0'){
        r_100 = ' ';
        if(r_10 =='0'){
            r_10 = ' ';
        }
    }
    if(g_100 == '0'){
        g_100 = ' ';
        if(g_10 =='0'){
            g_10 = ' ';
        }
    }    
    if(b_100 == '0'){
        b_100 = ' ';
        if(b_10 =='0'){
            b_10 = ' ';
        }
    }    
    
    line2[0] = 'R';
    line2[1] = r_100;
    line2[2] = r_10;
    line2[3] = r_1;
    line2[4] = ' ';
    line2[5] = 'G';
    line2[6] = g_100;
    line2[7] = g_10;
    line2[8] = g_1;
    line2[9] = ' ';    
    line2[10] = 'B';
    line2[11] = b_100;
    line2[12] = b_10;
    line2[13] = b_1;
    line2[14] = ' ';    
    line2[15] = ' ';    
    
    DspLine2Top();
    //sprintfgeʃI[o[ɂȂ̂ŃRgAEg
    //sprintf((char*)line2, "R%3d G%3d B%3d  ", red, green,blue);
    
    for( i = 0; i < LINE_MAX; i++ ){
        I2C1_Write1ByteRegister(SLAVE_ADRS,LINE1_ADRS,line2[i]);
    } 
}

/* End of File */